<?php
session_start();
if (!isset($_SESSION['email'])) {
    header('Location: login.php');
	return;
}

ini_set('display_errors', 'On');
error_reporting(E_ERROR);

// include db config class
require_once __DIR__ . '/db_config.php';

// to read spl char in vehid in payload
    $vehid = rawurldecode(str_replace('vehid=','',$_SERVER['QUERY_STRING']));
    
    $get_index_of_and_after_vehid = strpos($vehid,'&');
    
    if($get_index_of_and_after_vehid){
    
    $vehid = substr_replace($vehid, '', $get_index_of_and_after_vehid, strlen($vehid)) ;
    
    }


$chartQueries = array(
	"avg-fuel-efficiency" => array(" date, consumption from LOG_TABLE where consumption is not null and consumption > 0 and type = 0 ",  " order by date  "),
	"distance-between-fillups" => array( " date, dist from LOG_TABLE where dist is not null and dist > 0 and type = 0 ", " order by date"),
	"avg-price-per-volume" => array( " date, cost/qty as cost from LOG_TABLE where cost is not null and cost > 0 and qty is not null and qty > 0 and type = 0 ", " order by date"),
	
	
	"fill-ups-per-month" => array("  date, count(*) as fillups from LOG_TABLE where type = 0 ",  " group by month, year order by date  "),
	//"fuel-cost-per-distance" => array("  _id, cost, dist, partial_fill, date from LOG_TABLE where cost > 0 and dist > 0 and consumption > 0 and type = 0 ", " order by odo asc"),
	
	"trip-dist-by-type" => array(" SUM(qty - odo) as dist , service_type as type from LOG_TABLE WHERE type = 3 ", " group by service_type order by date "),
	"trip-tax-deduction-by-type" => array(" SUM(cost) as cost , service_type as type from LOG_TABLE WHERE type = 3 ", " group by service_type order by date ")
		
);

function getDateClause() {
	$dateClause = "";
	if (isset($_GET["startDate"]) && isset($_GET["endDate"])) {
		$dateClause = " AND date >= ".$_GET["startDate"]." AND date < ".$_GET["endDate"]." ";
	}
	return $dateClause;
}

function getUserAndVehicleClause($vehid) {
	return " VEHID = '".$vehid."' AND USER_ID = (SELECT USER_ID FROM USER_ID WHERE EMAIL = '".$_SESSION['email']."') ";
}

function getChartData($queryFragments,$vehid) {
	$conn = mysqli_connect(DB_SERVER,DB_USER,DB_PASSWORD,DB_DATABASE);
	$clause = " ".getUserAndVehicleClause($vehid)." ".getDateClause()." ";
	$query = "SELECT ".$queryFragments[0]." AND ".$clause." ".$queryFragments[1];
	error_log ("Running chart query: ".$query);
		
	$sth = mysqli_query($conn, $query);
	$rows = array();
	while($r = mysqli_fetch_assoc($sth)) {
	    $rows[] = $r;
	}
	print json_encode($rows);
}

function getFuelCostByDistance($vehid) {
	$conn = mysqli_connect(DB_SERVER,DB_USER,DB_PASSWORD,DB_DATABASE);
	$query = "SELECT _id, cost, dist, partial_fill, date  FROM LOG_TABLE WHERE cost > 0 AND dist > 0 AND consumption > 0 AND type = 0 AND ".getUserAndVehicleClause($vehid)." ".getDateClause()." ORDER BY odo ASC";
	error_log("Running chart query: ".$query);
	$result = $conn->query($query);

	$results = array();
	$prevDate = 0;
	$prevCost = 0;
	$prevDist = 0;
	$dateToCostMap = array();
	$dateToDistMap = array();
	if ($result->num_rows > 0) {
		while($row = $result->fetch_assoc()) {

			if ($row["partial_fill"] == 1) {
				$prevCost = $prevCost + $row["cost"];
				$prevDist = $prevDist + $row["dist"];
				$dateToCostMap[$row["date"]] = -1000;
				$dateToDistMap[$row["date"]] = $row["dist"];

			} else {
				$currCost = $prevCost + $row["cost"];
				$currDist = $prevDist + $row["dist"];
				$prevCost = 0;
				$prevDist = 0;
				
				
				$f = 0;
				if ($currDist != 0) {
					try {
						$f = $currCost/$currDist;
						if (is_nan($f)) {
							$f = 0;
						}
					} catch (Exception $e) {
						error_log("Exception");
						$f = 0;
					}
				}
				
				$dateToCostMap[$row["date"]] = $f;
				$dateToDistMap[$row["date"]] = $row["dist"];
				
			}
		}
		
		$currCpd = 0;
		$prevCpd = 0;
		krsort($dateToCostMap);
		
		foreach ($dateToCostMap as $key => $val) {
			
			$currCpd = $val;
			if ($currCpd == -1000) {
				$dateToCostMap[$key] = $prevCpd;
			} else {
				$prevCdp = $currCpd;
			}
		}
	}
	foreach ($dateToCostMap as $key => $val) {
		$map = array();
		$map["date"] = $key;
		$map["cost"] = $val;
		$map["dist"] = $dateToDistMap[$key];
		array_push($results, $map);
	}
	
	krsort($results);
	return $results;
}




function getFuelCostByMonth($vehid) {
	$conn = mysqli_connect(DB_SERVER,DB_USER,DB_PASSWORD,DB_DATABASE);
	$query = "SELECT date, sum(cost) as cost FROM LOG_TABLE WHERE type = 0 AND ".getUserAndVehicleClause($vehid)." ".getDateClause()." GROUP BY month, year ORDER BY odo asc ";
	
	error_log("Running chart query: ".$query);
	$result = $conn->query($query);

	$results = array();
	$prevDate = 0;
	if ($result->num_rows > 0) {
		while($row = $result->fetch_assoc()) {
				$map = array();
				$map["date"] = $row["date"];
				$map["cost"] = $row["cost"];
				array_push($results, $map);
		}
	}
	return $results;
}

function getFuelCostByDay($vehid) {

	$conn = mysqli_connect(DB_SERVER,DB_USER,DB_PASSWORD,DB_DATABASE);
	$query = "SELECT cost, date, missed_fill FROM LOG_TABLE WHERE cost > 0 AND type = 0 AND ".getUserAndVehicleClause($vehid)." ".getDateClause()." ORDER BY odo ASC";
	error_log("Running chart query: ".$query);
	$result = $conn->query($query);

	$results = array();
	$prevDate = 0;
	if ($result->num_rows > 0) {
		while($row = $result->fetch_assoc()) {
			if ($prevDate > 0 && $row["missed_fill"] == 0) {
				$currCost = $row["cost"];
				$currDate = $row["date"];
				
				$days = ($currDate - $prevDate)/(1000*60*60*24);
				
				$f = 0;
				if ($days != 0) {
					try {
						$f = $currCost/$days;
						if (is_nan($f)) {
							$f = 0;
						}
					} catch (Exception $e) {
						error_log("Exception");
						$f = 0;
					}
				}
				$map = array();
				$map["date"] = $row["date"];
				$map["cost"] = $f;
				array_push($results, $map);
			}
			$prevDate = $row["date"];
		}
		return $results;
	} else {
		return $results;
	}
}


function getSECostByDistanceData($type,$vehid) {
	$conn = mysqli_connect(DB_SERVER,DB_USER,DB_PASSWORD,DB_DATABASE);
	$query = "SELECT odo, cost, date FROM LOG_TABLE WHERE cost > 0 AND type = {$type} AND ".getUserAndVehicleClause($vehid)." ".getDateClause()." ORDER BY odo ASC";
	error_log("Running chart query: ".$query);
	$result = $conn->query($query);
	
	$results = array();
	$prevOdo = 0;
	if ($result->num_rows > 0) {
		while($row = $result->fetch_assoc()) {
			if ($prevOdo > 0) {
				
				$currCost = $row["cost"];
				$f = 0;
				try {
					$d = $row["odo"] - $prevOdo;
					if (is_nan($d) || $d == 0) {
						$f = 0;
					} else {
						$f = $currCost/($row["odo"] - $prevOdo);
						if (is_nan($f)) {
							$f = 0;
						}
					}
				} catch (Exception $e) {
					$f = 0;
				}
				$map = array();
				$map["date"] = $row["date"];
				$map["cost"] = $f;
				array_push($results, $map);
			}
			$prevOdo = $row["odo"];
		}
		return $results;
	} else {
		return $results;
	}
}

function getSECostByDayData($type,$vehid) {

	$conn = mysqli_connect(DB_SERVER,DB_USER,DB_PASSWORD,DB_DATABASE);
	$query = "SELECT cost, date FROM LOG_TABLE WHERE cost > 0 AND type = {$type} AND ".getUserAndVehicleClause($vehid)." ".getDateClause()." ORDER BY odo ASC";
	error_log("Running chart query: ".$query);
	$result = $conn->query($query);
	
	$results = array();
	$prevDate = 0;
	if ($result->num_rows > 0) {
		while($row = $result->fetch_assoc()) {
			if ($prevDate > 0) {
				
				$currCost = $row["cost"];
				$currDate = $row["date"];
				
				$days = ($currDate - $prevDate)/(1000*60*60*24);
				
				$f = 0;
				if ($days != 0) {
					try {
						$f = $currCost/$days;
						if (is_nan($f)) {
							$f = 0;
						}
					} catch (Exception $e) {
						error_log("Exception");
						$f = 0;
					}
				}
				$map = array();
				$map["date"] = $row["date"];
				$map["cost"] = $f;
				array_push($results, $map);
			}
			$prevDate = $row["date"];
		}
		return $results;
	} else {
		return $results;
	}
}


$chartName = $_GET["chart-name"];
if ($chartName == "service-cost-per-distance") {
	print json_encode(getSECostByDistanceData(1,$vehid));
} else if ($chartName == "service-cost-per-day") {
	print json_encode(getSECostByDayData(1,$vehid));
} else if ($chartName == "expense-cost-per-distance") {
	print json_encode(getSECostByDistanceData(2,$vehid));
} else if ($chartName == "expense-cost-per-day") {
	print json_encode(getSECostByDayData(2,$vehid));
} else if ($chartName == "fuel-cost-per-day") {
	print json_encode(getFuelCostByDay($vehid));
} else if ($chartName == "fuel-cost-per-month") {
	print json_encode(getFuelCostByMonth($vehid));		
} else if ($chartName == "fuel-cost-per-distance") {
	print json_encode(getFuelCostByDistance($vehid));	
} else {
	getChartData($chartQueries[$chartName],$vehid);
}
?>


