<?php
	session_start();
	if (!isset($_SESSION['email'])) {
	    header('Location: login.php');
		return;
	}
	
	ini_set('display_errors', 'On');
	error_reporting(E_ERROR);

	// include db config class
	require_once __DIR__ . '/db_config.php';
	require_once __DIR__ . '/util.php';
	
	// to read spl char in vehid in payload
    $vehid = rawurldecode(str_replace('vehid=','',$_SERVER['QUERY_STRING']));
    
    $get_index_of_and_after_vehid = strpos($vehid,'&');
    
    if($get_index_of_and_after_vehid){
    
    $vehid = substr_replace($vehid, '', $get_index_of_and_after_vehid, strlen($vehid)) ;
    
    }

	$totalStatsQueries = array(
		"distance" => array(" MAX(odo) - MIN(odo) as result FROM LOG_TABLE ", 0),
		"fill-ups" => array(" COUNT(*) as result FROM LOG_TABLE WHERE TYPE = 0 ", 1),
		"fuel-qty" => array(" TRUNCATE(SUM(QTY), 2) as result FROM LOG_TABLE WHERE TYPE = 0 ", 1),
		"fuel-cost" => array(" SUM(COST) as result FROM LOG_TABLE WHERE TYPE = 0 ", 1),
		"services" => array(" COUNT(*) as result FROM LOG_TABLE WHERE TYPE = 1", 1),
		"service-cost" => array(" SUM(COST) as result FROM LOG_TABLE WHERE TYPE = 1 ", 1),
		"other-expenses" => array(" SUM(COST) as result FROM LOG_TABLE WHERE TYPE = 2 	", 1)
	);
	
	
	$avgFuelStatusQueries = array(
		"avg-fuel-efficiency" => array(" avg(consumption) as result from LOG_TABLE where consumption is not null and consumption > 0 and type = 0 ",  1),
		"dist-between-fillups" => array(" AVG(dist) as result FROM LOG_TABLE WHERE dist > 0 AND type = 0 ", 1),
		"qty-per-fillup" => array(" AVG(qty) as result  FROM LOG_TABLE WHERE type = 0 ", 1),
		"cost-per-fillup" => array(" AVG(cost) as result  FROM LOG_TABLE WHERE cost != 0 AND type = 0 ", 1),
		"avg-price-per-volume" => array(" AVG(cost/qty) as result  FROM LOG_TABLE WHERE cost != 0 AND type = 0 ", 1),
		"fuel-cost-per-distance" => array(" SUM(COST) / SUM(dist) as result FROM LOG_TABLE WHERE dist > 0 and cost > 0 and consumption > 0 and TYPE = 0 ", 1)

	);
	
	// These are typically used by the UI to generate some stats
	$helperQueries = array(
		"fuel-cost-excluding-this-month" => array(' SUM(COST) as result FROM LOG_TABLE WHERE TYPE = 0 AND STRCMP(DATE_FORMAT(NOW(), "%Y%m"), DATE_FORMAT(FROM_UNIXTIME(date/1000), "%Y%m"))  != 0 ', 1),
		"fillups-excluding-this-month" => array(' COUNT(*) as result from LOG_TABLE WHERE TYPE = 0 AND STRCMP(DATE_FORMAT(NOW(), "%Y%m"), DATE_FORMAT(FROM_UNIXTIME(date/1000), "%Y%m"))  != 0 ' , 1),
		"months-since-first-fillup" => array(" MAX(PERIOD_DIFF(EXTRACT(YEAR_MONTH FROM NOW()), EXTRACT(YEAR_MONTH FROM FROM_UNIXTIME(date/1000))))  as result from LOG_TABLE WHERE TYPE = 0 ", 1),
		"days-since-first-fillup" => array(" 1 + (MAX(date)/(1000*60*60*24)) - (MIN(date)/(1000*60*60*24)) as result FROM LOG_TABLE where TYPE = 0 AND cost != 0", 1)
	);
	
	$avgServiceStats = array(
		"service-cost-per-distance" => array(" SUM(cost) / (MAX(odo) - MIN(odo)) as result FROM LOG_TABLE WHERE cost > 0 and type = 1 ", 1),
		"service-cost" => array(" SUM(cost) as result FROM LOG_TABLE WHERE cost > 0 and type = 1 ", 1),
		"service-days" => array(" 1 + (MAX(date)/(1000*60*60*24)) - (MIN(date)/(1000*60*60*24)) as result FROM LOG_TABLE WHERE cost > 0 and type = 1 ", 1)
	);
		
	$otherStats = array(
		"tax-deduction" => array(" SUM(cost) as result FROM LOG_TABLE WHERE type = 3 ", 1),
	);
	
	$avgOtherExpenseStats = array(
		"expense-cost-per-distance" => array(" SUM(cost) / (MAX(odo) - MIN(odo)) as result FROM LOG_TABLE WHERE cost > 0 and type = 2 ", 1),
		"expense-cost" => array(" SUM(cost) as result FROM LOG_TABLE WHERE cost > 0 and type = 2 ", 1),
		"expense-days" => array(" 1 + (MAX(date)/(1000*60*60*24)) - (MIN(date)/(1000*60*60*24)) as result FROM LOG_TABLE WHERE cost > 0 and type = 2 ", 1)
	);	

	$tripQueries = array(
		"total-trips" => array(" COUNT(*) as result FROM LOG_TABLE WHERE type = 3 ", 1),
		"total-trip-distance" => array(" SUM(qty - odo) as result FROM LOG_TABLE WHERE type = 3 ", 1),
		"total-trip-time" => array(" SUM(consumption - date) as result FROM LOG_TABLE WHERE type = 3 ", 1),
		"total-tax-deduction" => array(" SUM(cost) as result FROM LOG_TABLE WHERE type = 3 ", 1),
		"trip-distance-by-type" => array(" SUM(cost) as result FROM LOG_TABLE WHERE type = 3 ", 1),
	);	

	
	function runQueries(&$results, &$resultMap, $map, $conn,$vehid) {
		$dateClause = "";
		if (isset($_GET["startDate"]) && isset($_GET["endDate"])) {
			$dateClause = " AND date >= ".$_GET["startDate"]." AND date < ".$_GET["endDate"]." ";
		}
		
		$userAndVehicleClause = " VEHID = '".$vehid."' AND USER_ID = (SELECT USER_ID FROM USER_ID WHERE EMAIL = '".$_SESSION['email']."') ".$dateClause;
		$query = "";
		foreach ($map as $key => $array) {
			if ($array[1] == 0) {
				$query = "SELECT ".$array[0]." WHERE ".$userAndVehicleClause;
			} else {
				$query = "SELECT ".$array[0]." AND ".$userAndVehicleClause;
			}
			
			error_log("For {$key}, running dashboard query: ".$query);
			
			try {
				$result = $conn->query($query);
				
				if ($result->num_rows > 0) {
				    $row = $result->fetch_assoc();
					if ($row["result"] == null || $row["result"] == "") {
						array_push($results, '"'.$key.'":0');
						$resultMap[$key] = '"N/A"';
					} else {
						array_push($results, '"'.$key.'":'.$row["result"]);
						$resultMap[$key] = $row["result"];
					}
				} else {
					error_log("No results. Adding 0");
					array_push($results, '"'.$key.'":0');
					$resultMap[$key] = 0;
				}
			} catch (Exception $e) {
			    echo 'Caught exception: ',  $e->getMessage(), "\n";
				array_push($results, '"'.$key.'":0');
				$resultMap[$key] = 0;
			}
		}
	}
	
	$results = array();
	$resultMap = array();
	$conn = mysqli_connect(DB_SERVER,DB_USER,DB_PASSWORD,DB_DATABASE);
	runQueries($results, $resultMap, $totalStatsQueries, $conn,$vehid);
	runQueries($results, $resultMap, $avgFuelStatusQueries, $conn,$vehid);
	runQueries($results, $resultMap, $avgServiceStats, $conn,$vehid);
	runQueries($results, $resultMap, $avgOtherExpenseStats, $conn,$vehid);
	runQueries($results, $resultMap, $otherStats, $conn,$vehid);
	runQueries($results, $resultMap, $helperQueries, $conn,$vehid);
	runQueries($results, $resultMap, $tripQueries, $conn,$vehid);
	
	// Calculate any generated stats from the helper queries
	
	$runningCost = floatVal($resultMap["fuel-cost-per-distance"]) +
		floatVal($resultMap["service-cost-per-distance"]) + floatVal($resultMap["expense-cost-per-distance"]);
	array_push($results, '"running-cost":'.$runningCost);
	
	$val = 0;
	if (floatval($resultMap["months-since-first-fillup"]) == 0) {
		$val = '"N/A"';
	} else {
		$val = floatval($resultMap["fillups-excluding-this-month"]) / floatval($resultMap["months-since-first-fillup"]);
	}
	array_push($results, '"fill-ups-per-month":'.$val);
	
	if (floatval($resultMap["months-since-first-fillup"]) == 0) {
		$val = '"N/A"';
	} else {
		$val = floatval($resultMap["fuel-cost-excluding-this-month"]) / floatval($resultMap["months-since-first-fillup"]);
	}
	array_push($results, '"fuel-cost-per-month":'.$val);

	if (floatval($resultMap["days-since-first-fillup"]) == 0) {
		$val = '"N/A"';
	} else {
		$val = floatval($resultMap["fuel-cost"]) / floatval($resultMap["days-since-first-fillup"]);
	}
	array_push($results, '"fuel-cost-per-day":'.$val);
	
	if (floatval($resultMap["service-days"]) == 0 || floatval($resultMap["service-cost"]) == 0 ) {
		$val = '"N/A"';
	} else {
		$val = floatval($resultMap["service-cost"]) / floatval($resultMap["service-days"]);
	}
	array_push($results, '"service-cost-per-day":'.$val);
	
	if (floatval($resultMap["expense-days"]) == 0 || floatval($resultMap["expense-cost"]) == 0 ) {
		$val = '"N/A"';
	} else {
		$val = floatval($resultMap["expense-cost"]) / floatval($resultMap["expense-days"]);
	}
	array_push($results, '"expense-cost-per-day":'.$val);
	
	// Add the trip queries from util.php
	$distanceMap = getMaxTripTypeByDistance();
	array_push($results, '"trip-distance-by-type":'.$distanceMap["dist"]);
	array_push($results, '"trip-distance-by-type-type":"'.$distanceMap["type"].'"');
	
	$taxDeductionMap = getMaxTripTypeByTaxDeduction();
	array_push($results, '"tax-deduction-by-type":'.$taxDeductionMap["cost"]);
	array_push($results, '"tax-deduction-by-type-type":"'.$taxDeductionMap["type"].'"');
	
	mysqli_close($conn);
	echo "{".join(",", $results)."}";
?>