<?php
	session_start();
	if (!isset($_SESSION['email'])) {
	    header('Location: login.php');
		return;
	}
?>
                <!-- Page Heading -->
                <div class="row">
                    <div class="col-lg-12">
                        <h1 class="page-header">
                            Dashboard
                        </h1>
                    </div>
                </div>
                <!-- /.row -->
				
				<div class="row" style="margin-bottom: 10px">
					<div class="dropdown col-lg-2 col-md-2 darkdropdown">
						<button class="btn btn-default dropdown-toggle pull-left" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="true" style="width:150px;" id="date-range-dropdown">
							<span id="current-date-range"><b>All Time</b></span>
							<span class="caret"></span>
						</button>
						<ul style="margin-right: 15px" class="dropdown-menu pull-right" aria-labelledby="date-range-dropdown" style="font-weight:bold">
							<li><a class="date-range-link" data-date-range='all'><b>All Time</b></a></li>
							<li><a class="date-range-link" data-date-range='thisMonth'><b>This Month</b></a></li>
							<li><a class="date-range-link" data-date-range='lastMonth'><b>Last Month</b></a></li>
							<li><a class="date-range-link" data-date-range='thisYear'><b>This Year</b></a></li>
							<li><a class="date-range-link" data-date-range='custom'><b>Custom</b></a></li>
						</ul>
						
					</div>
					<div class="col-lg-8 col-md-8" id="custom-date-range" style="display:none">
						<form class="form-inline" role="form">
						<div class="form-group">
							  <input class="form-control col-lg-2 col-md-2 pull-left" id="dash-start-date" type="text"></input> 
							  <label style="padding:5px;"> - </label>
							  <div id="custom-date-range-error" style="color: #f00; padding: 5px;" class="pull-right"></div>
							  <button type="button" class="btn btn-primary pull-right" id="dash-custom-date-search" style="margin-left: 5px;">Apply</button>
							  <input class="form-control col-lg-2 col-md-2 pull-right" id="dash-end-date" type="text"></input>
							  
						</div>
						</form>	
					</div>
				</div>

				<div class="row">
					<div class="col-lg-3 col-md-3">
						<div class="panel panel-fbbox">
							<div class="panel-heading fbbox">
								<div class="row">
									<div class="col-xs-3">
										<i class="fa fa-car fa-2x"></i>
									</div>
									<div class="col-xs-9 text-right fbbox" style="padding-left:0px">
										<div class="stats-font"><span id="avg-fuel-efficiency-box-stat"></span> <?= $_SESSION["consumption_unit"] ?></div>
										<div>Avg Fuel Efficiency</div>
									</div>
								</div>
							</div>
						</div>
					</div>
					<div class="col-lg-3 col-md-3">
						<div class="panel panel-fbbox">
							<div class="panel-heading fbbox">
								<div class="row">
									<div class="col-xs-3">
										<i class="fa fa-dollar fa-2x"></i>
									</div>
									<div class="col-xs-9 text-right">
										<div class="stats-font"><span id="fuel-cost-per-distance-box-stat"></span> <?= $_SESSION["currency"] ?></div>
										<div>Fuel Cost/<?= $_SESSION["distance_unit"] ?></div>
									</div>
								</div>
							</div>
						</div>
					</div>
					<div class="col-lg-3 col-md-3">
						<div class="panel panel-fbbox">
							<div class="panel-heading fbbox">
								<div class="row">
									<div class="col-xs-3">
										<i class="fa fa-dollar fa-2x"></i>
									</div>
									<div class="col-xs-9 text-right">
										<div class="stats-font"><span id="running-cost-box-stat"> </span> <?= $_SESSION["currency"] ?></div>
										<div>Running Cost/<?= $_SESSION["distance_unit"] ?></div>
									</div>
								</div>
							</div>
						</div>
					</div>
					<div class="col-lg-3 col-md-3">
						<div class="panel panel-fbbox">
							<div class="panel-heading fbbox">
								<div class="row">
									<div class="col-xs-3">
										<i class="fa fa-dollar fa-2x"></i>
									</div>
									<div class="col-xs-9 text-right">
										<div class="stats-font"><span id="tax-deduction-box-stat"> </span> <?= $_SESSION["currency"] ?></div>
										<div>Tax Deduction</div>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
				
				
				<!-- Start: panel for stats table and chart -->
				<div class="panel panel-default" style="background-color: #3c3e47 !important;">
				<div class="panel-body">
					  
				<!-- Start: Stats dropdown row -->	  
				<div class="row" style="margin-bottom: 10px;">
					<div class="dropdown col-lg-5 col-md-5 darkdropdown">
						<button class="btn btn-default dropdown-toggle" type="button"  data-toggle="dropdown" aria-haspopup="true" aria-expanded="true" style="width:250px" id="stats-dropdown">
							<span id="current-stat-name"><b>Avg Fuel Stats</b></span>
							<span class="caret"></span>
						</button>
						<ul style="margin-left:15px;" class="dropdown-menu" aria-labelledby="stats-dropdown" style="font-weight:bold">
							<li><a class="stats-link" data-stat-name='total-stats-table' data-default-chart='no-default'><b>Total Stats</b></a></li>
							<li><a class="stats-link" data-stat-name='avg-fuel-stats-table' data-default-chart='showAvgFuelEfficiencyChart'><b>Avg Fuel Stats</b></a></li>
							<li><a class="stats-link" data-stat-name='service-stats-table' data-default-chart='showServiceCostPerDistanceChart'><b>Avg Service Stats</b></a></li>
							<li><a class="stats-link" data-stat-name='other-expenses-stats-table' data-default-chart='showExpenseCostPerDistanceChart'><b>Avg Other Expenses Stats</b></a></li>
							<li><a class="stats-link" data-stat-name='total-trips-stats-table' data-default-chart='showTripDistanceByTypeChart'><b>Trip Stats</b></a></li>
						</ul>
					</div>
				</div>
				<!-- End: Stats dropdown row -->	

				<!-- Start: Stats and chart row -->	
				<div class="row">
					<div class="col-lg-5">
						<div class="panel panel-default">
						  <div class="panel-heading">
						    <h3 class="panel-title"><span id="stats-table-name">Total Stats</span></h3>
						  </div>
						  <div class="panel-body">
								<div id="total-stats-table" class="stats-table" style="display:none;">
									<table class="table  ">
										<tbody>
											<tr>
												<td>Distance</td>
												<td><span id="distance-stat"></span> <?= $_SESSION["distance_unit"] ?></td>
												<td></td>
											</tr>
											<tr>
												<td>Fillups</td>
												<td><span id="fill-ups-stat"></span></td>
												<td></td>
												<!-- <td><a class="chart-link" data-chart-function='showFillUpsPerMonthChart'><i class="fa fa-fw fa-bar-chart"></i></a></td> -->
											</tr>
											<tr>
												<td>Fuel Qty</td>
												<td><span id="fuel-qty-stat"></span> <?= $_SESSION["volume_unit"] ?></td>
												<td></td>
											</tr>
											<tr>
												<td>Fuel Cost</td>
												<td><span id="fuel-cost-stat"></span> <?= $_SESSION["currency"] ?></td>
												<td></td>
											</tr>
											<tr>
												<td>Service Cost</td>
												<td><span id="service-cost-stat"></span> <?= $_SESSION["currency"] ?></td>
												<td></td>
											</tr>
											<tr>
												<td>Other Expenses</td>
												<td><span id="other-expenses-stat"></span> <?= $_SESSION["currency"] ?></td>
												<td></td>
											</tr>
										</tbody>
									</table>
								</div>

								<div id="service-stats-table" class="stats-table" style="display:none;">
				                    <table class="table  ">
				                        <tbody>
				                            <tr>
				                                <td>Service Cost/<?= $_SESSION["distance_unit"] ?></td>
				                                <td><span id="service-cost-per-distance-stat"></span> <?= $_SESSION["currency"] ?></td>
												<td><a class="chart-link" data-chart-function='showServiceCostPerDistanceChart'><i class="fa fa-fw fa-bar-chart"></i></a></td>
				                            </tr>
				                            <tr>
				                                <td>Service Cost/day</td>
				                                <td><span id="service-cost-per-day-stat"></span> <?= $_SESSION["currency"] ?></td>	
												<td><a class="chart-link" data-chart-function='showServiceCostPerDayChart'><i class="fa fa-fw fa-bar-chart"></i></a></td>
				                            </tr>
				                        </tbody>
				                    </table>
								</div>
	
								<div id="other-expenses-stats-table" class="stats-table" style="display:none;">
				                    <table class="table  ">
				                        <tbody>
				                            <tr>
				                                <td>Expense Cost/<?= $_SESSION["distance_unit"] ?></td>
				                                <td><span id="expense-cost-per-distance-stat"></span> <?= $_SESSION["currency"] ?></td></td>
												<td><a class="chart-link" data-chart-function='showExpenseCostPerDistanceChart'><i class="fa fa-fw fa-bar-chart"></i></a></td>
				                            </tr>
				                            <tr>
				                                <td>Expense Cost/day</td>
				                                <td><span id="expense-cost-per-day-stat"></span> <?= $_SESSION["currency"] ?></td>
												<td><a class="chart-link" data-chart-function='showExpenseCostPerDayChart'><i class="fa fa-fw fa-bar-chart"></i></a></td>
				                            </tr>
				                        </tbody>
				                    </table>
								</div>
								
								<div id="total-trips-stats-table" class="stats-table" style="display:none;">
				                    <table class="table  ">
				                        <tbody>
				                            <tr>
				                                <td>Total Trips</td>
				                                <td><span id="total-trips-stat"></span></td>
												<td></td>
				                            </tr>
											<tr>
				                                <td>Total Trip Distance</td>
				                                <td><span id="total-trip-distance-stat"></span> <?= $_SESSION["distance_unit"] ?></td></td>
												<td></td>
				                            </tr>
				                            <tr>
				                                <td>Total Trip Time</td>
				                                <td><span id="total-trip-time-stat"></span></td></td>
												<td></td>
				                            </tr>
				                            <tr>
				                                <td>Total Tax Deduction</td>
				                                <td><span id="total-tax-deduction-stat"></span> <?= $_SESSION["currency"] ?></td></td>
												<td></td>
				                            </tr>
											<tr>
				                                <td>Trip Distance by Type (<span id="trip-distance-by-type-type-stat"></span>)</td>
				                                <td><span id="trip-distance-by-type-stat"></span> <?= $_SESSION["distance_unit"] ?></td></td>
												<td><a class="chart-link" data-chart-function='showTripDistanceByTypeChart'><i class="fa fa-fw fa-bar-chart"></i></a></td>
				                            </tr>
				                            <tr>
				                                <td>Tax Deduction by Type (<span id="tax-deduction-by-type-type-stat"></span>)</td>
				                                <td><span id="tax-deduction-by-type-stat"></span> <?= $_SESSION["currency"] ?></td></td>
												<td><a class="chart-link" data-chart-function='showTaxDeductionByTypeChart'><i class="fa fa-fw fa-bar-chart"></i></a></td>
				                            </tr>
											
				                        </tbody>
				                    </table>
								</div>
					
								<div id="avg-fuel-stats-table" class="stats-table">
				                    <table class="table  ">
				                        <tbody>
											<tr class="current-chart">
												<td>Avg Fuel Efficiency</td>
												<td><span id="avg-fuel-efficiency-stat"></span> <?= $_SESSION["consumption_unit"] ?></td>
												<td><a class="chart-link" data-chart-function='showAvgFuelEfficiencyChart'><i class="fa fa-fw fa-bar-chart"></i></a></td>
											</tr>
											<tr>
				                                <td>Distance Between Fill-Ups</td>
				                                <td><span id="dist-between-fillups-stat"></span> <?= $_SESSION["distance_unit"] ?></td>
												<td><a class="chart-link" data-chart-function='showDistanceBetweenFillupsChart'><i class="fa fa-fw fa-bar-chart"></i></a></td>
				                            </tr>
				                            <tr>
				                                <td>Qty Per Fill-Up</td>
				                                <td><span id="qty-per-fillup-stat"></span> <?= $_SESSION["volume_unit"] ?></td>
												<td></td>
				                            </tr>
				                            <tr>
				                                <td>Cost Per Fill-Up</td>
				                                <td><span id="cost-per-fillup-stat"></span> <?= $_SESSION["currency"] ?></td>
												<td></td>
				                            </tr>
				                            <tr>
				                                <td>Avg Price/<?= $_SESSION["volume_unit"] ?></td>
				                                <td><span id="avg-price-per-volume-stat"></span> <?= $_SESSION["currency"] ?></td>
												<td><a class="chart-link" data-chart-function='showPricePerVolumeChart'><i class="fa fa-fw fa-bar-chart"></i></a></td>
				                            </tr>
				                            <tr>
				                                <td>Fill-Ups per Month</td>
				                                <td><span id="fill-ups-per-month-stat"></span></td>
												<td><a class="chart-link" data-chart-function='showFillUpsPerMonthChart'><i class="fa fa-fw fa-bar-chart"></i></a></td>
				                            </tr>
				                            <tr>
				                                <td>Fuel Cost/<?= $_SESSION["distance_unit"] ?></td>
				                                <td><span id="fuel-cost-per-distance-stat"></span> <?= $_SESSION["currency"] ?></td>
												<td><a class="chart-link" data-chart-function='showFuelCostByDistanceChart'><i class="fa fa-fw fa-bar-chart"></i></a></td>
				                            </tr>
				                            <tr>
				                                <td>Fuel Cost/day</td>
				                                <td><span id="fuel-cost-per-day-stat"></span> <?= $_SESSION["currency"] ?></td>
												<td><a class="chart-link" data-chart-function='showFuelCostByDayChart'><i class="fa fa-fw fa-bar-chart"></i></a></td>
				                            </tr>
				                            <tr>
				                                <td>Fuel Cost/month</td>
				                                <td><span id="fuel-cost-per-month-stat"></span> <?= $_SESSION["currency"] ?></td>
												<td><a class="chart-link" data-chart-function='showFuelCostByMonthChart'><i class="fa fa-fw fa-bar-chart"></i></a></td>
				                            </tr>
				                        </tbody>
				                    </table>
								</div>
							</div> <!-- end panel body -->
						</div><!-- end panel -->
					</div> <!-- end lg-5 -->
					
	                <div class="col-lg-7 hidden" id="chart-area">
						<div class="panel panel-default">
	                        <div class="panel-heading">
	                            <h3 class="panel-title"><span id="chart-title"></h3>
	                        </div>
	                        <div class="panel-body">
	                            <div id="chart-body">
									<i class='fa fa-spinner fa-spin'></i>  Loading ...
	                            </div>
	                        </div>
	                    </div>
	                </div>

				<!-- End: Stats dropdown row -->	
				</div>
				
				<!-- End: panel for stats table and chart  -->
				</div>
				</div>
				
				<div class="row">
					
					<div class="col-lg-5">
						<!-- 5 reminders table -->
						
						<div class="panel panel-default">
						  <div class="panel-heading">
						    <h3 class="panel-title">Upcoming Reminders</h3>
						  </div>
						  <div class="panel-body">
			                <div>
			                    <table class="table  ">
			                        <thead>
			                        </thead>
			                        <tbody id="reminders_area">
			                        </tbody>
			                    </table>
			                </div>
						  </div>
						  <div class="panel-footer">
							  <div>
								  <a href="#reminders">View All</a>
							  </div>
						  </div>
						</div>
					</div>
					
					
					<div class="col-lg-7">
						<!-- Mini logs table -->
						<div class="panel panel-default">
						  <div class="panel-heading">
						    <h3 class="panel-title">Recent Logs</h3>
						  </div>
						  <div class="panel-body">
			                <div class="table-responsive">
			                    <table width="75%" id="mini-logs-table" class="table  ">
			                        <thead>
			                            <tr>
			                                <th class="col-sm-1">Type</th>
			                                <th>Date</th>
			                                <th>Details</th>
			                                <th>Cost</th>
			                            </tr>
			                        </thead>
			                        <tbody>
			                            <!-- Dynamically retrieved logs go here -->
			                        </tbody>
			                    </table>
			                </div>
						  </div>
						  <div class="panel-footer">
							  <div>
								  <a href="#log">View All</a>
							  </div>
						  </div>
						</div>
					</div>
				</div>

