var fuelbuddy = {};

fuelbuddy.current_vehicle_id = "";
fuelbuddy.global_settings = {};
fuelbuddy.IMAGES_PREFIX = "FuelBuddyImages/";
fuelbuddy.RECEIPTS_PREFIX = "FuelBuddyReceipts/";
fuelbuddy.ASSET_ICON_PREFIX = "http://www.fuelbuddy-app.com/DatabaseScriptsTemp/assets/";

fuelbuddy.VEH_READ_PHP = "db/get_vehicles.php";
fuelbuddy.VEH_UPDATE_PHP = "db/veh_data.php";
fuelbuddy.LOGS_PHP = "db/get_logs.php";
fuelbuddy.SETTINGS_PHP = "db/get_settings.php";
fuelbuddy.LOGS_UPDATE_PHP = "db/log_data.php";
fuelbuddy.DASHBOARD_STATS_PHP = "db/get_dashboard.php";
fuelbuddy.REMINDERS_PHP = "db/get_reminders.php";
fuelbuddy.CHARTS_PHP = "db/get_charts.php";
fuelbuddy.VALIDATE_ODO_AND_DATE = "db/validate_odo_and_date.php";

fuelbuddy.maxValues = {}
fuelbuddy.vehIds = []
fuelbuddy.current_user_email = ''

fuelbuddy.fragments = {
	"": "dashboard_fragment.php",
	"#": "dashboard_fragment.php",
	"log": "log_fragment.html",
	"dashboard": "dashboard_fragment.php",
	"vehicles": "vehicles_fragment.html",
	"about": "about_fragment.html",
	"settings": "settings_fragment.php",
	"reminders": "reminders_fragment.php"
};

fuelbuddy.getHashValue = function() {
	var hash = "##" + window.location.hash;
	return hash.substring(hash.lastIndexOf("#") + 1);
}

fuelbuddy.logTypes = {
	0: "Fill-Up",
	1: "Service",
	2: "Expense",
	3: "Trip"
}

fuelbuddy.editLogFragments = {
	0: "add_fill_up_fragment.php",
	1: "add_service_fragment.php",
	2: "add_expense_fragment.php",
	3: "add_trip_fragment.php"
}

fuelbuddy.serviceTypeIcons = {
	0: fuelbuddy.ASSET_ICON_PREFIX + "fillup_icon.png",
	1: fuelbuddy.ASSET_ICON_PREFIX + "service.png",
	2: fuelbuddy.ASSET_ICON_PREFIX + "expense_icon.png",
	3: fuelbuddy.ASSET_ICON_PREFIX + "trip_icon.png",
}

fuelbuddy.updateGlobalSettings = function(force, callback) {
	fuelbuddy.global_settings = {};
	
	var forceString = force ? "?force=1" : "force=0";
	jQuery.get(fuelbuddy.SETTINGS_PHP + forceString, "", function(data) { 
		$.each(data, function(key, value) {
			fuelbuddy.global_settings[key] = value;
		});
		
		if (callback) {
			callback();
		}
	}, "json")
}

fuelbuddy.updateGlobalSettingsAndInitApp = function() {
	fuelbuddy.showMobileWarning();
	fuelbuddy.global_settings = {};
	
	jQuery.get(fuelbuddy.SETTINGS_PHP, "", function(data) { 
		$.each(data, function(key, value) {
			fuelbuddy.global_settings[key] = value;
		});
		fuelbuddy.setCurrentUserEmail();
		fuelbuddy.updateUsername();
		fuelbuddy.updateVehicleDropdown(fuelbuddy.updateMainFragment);
	}, "json")
}

fuelbuddy.getDateRanges = function() {
	var today = new Date();
	
	var thisMonthStart = new Date();
	thisMonthStart.setDate(1);
	var thisMonthEnd = new Date();
	thisMonthEnd.setMonth(today.getMonth() + 1);
	thisMonthEnd.setDate(1);
	
	var lastMonthStart = new Date();
	lastMonthStart.setMonth(today.getMonth() - 1);
	lastMonthStart.setDate(1);
	var lastMonthEnd = new Date();
	lastMonthEnd.setDate(1);
	
	var thisYearStart = new Date();
	thisYearStart.setDate(1);
	thisYearStart.setMonth(0);
	
	var thisYearEnd = new Date();
	thisYearEnd.setDate(today.getDate() + 1);

	return {
		"allStart": 0,
		"allEnd": today.getTime(),
		"thisMonthStart": thisMonthStart.getTime(),
		"thisMonthEnd": thisMonthEnd.getTime(),
		"lastMonthStart": lastMonthStart.getTime(),
		"lastMonthEnd": lastMonthEnd.getTime(),
		"thisYearStart": thisYearStart.getTime(),
		"thisYearEnd": thisYearEnd.getTime(),
	}
	
}

fuelbuddy.getMonthAndYear = function(date) {
	var months = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
	//return ("0"+(date.getMonth()+1)).slice(-2) + "/" + date.getFullYear();
	return ("0"+(date.getMonth()+1)).slice(-2) + "/" + date.getFullYear();
}

fuelbuddy.getDayMonthAndYear = function(date) {
	var months = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
//	return ("0"+(date.getDate())).slice(-2) + "/" + ("0"+(date.getMonth()+1)).slice(-2) + "/" + date.getFullYear();
	return ("0"+(date.getDate())).slice(-2) + "-" + months[date.getMonth()] + "-" + date.getFullYear();
}


fuelbuddy.updateNav = function() {
	var navid = fuelbuddy.getHashValue();
	if (navid == '') {
		navid = "dashboard";
	}
	$("#leftnav").children().removeClass("active");
	$("#leftnav #" + navid + "nav").addClass("active");
};

fuelbuddy.updateMainFragment = function() {
	var insertFragment = function(data) {
		$("#container_fluid").html(data);
		var navid = fuelbuddy.getHashValue();
		if (navid == '') { 
			navid = "dashboard";
		}
		if (fuelbuddy[navid + "Behavior"]) {
			fuelbuddy[navid + "Behavior"]();
		}
		
		fuelbuddy.showMobileWarning();
	}
	
	jQuery.get("fragments/" + fuelbuddy.fragments[fuelbuddy.getHashValue()], "", insertFragment, "html")
	fuelbuddy.updateNav();
}

fuelbuddy.validateOdoAndDate = function(inputOdo, inputDate, callback) {
	
	if (new Date(parseInt(inputDate)) == "Invalid Date") {
		$("#add-log-error").html("Please specify a valid date");
		$("#add-log-error").show();
		$("#add-log-submit-button").html("Submit");
		return;
	}
	
	jQuery.getJSON(fuelbuddy.VALIDATE_ODO_AND_DATE + "?inputDate=" +
				inputDate + "&inputOdo=" + 
				inputOdo + "&vehid=" + 
				fuelbuddy.current_vehicle_id,
			"", function(data) {
				
		if (!data["valid"]) {
			$("#add-log-error").html("Please ensure odometer value and selected date are valid");
			$("#add-log-error").show();
			$("#add-log-submit-button").html("Submit");
		} else {
			if (callback) {
				callback();
			}
		}
	});
}

fuelbuddy.updateVehicleDropdown = function(callback) {
    // Get the vehicles and populate the dropdown
	$("#vehicle_dropdown").empty();
	jQuery.getJSON(fuelbuddy.VEH_READ_PHP, "", function(data) {
		var first = true;
		$.each(data, function(index, item) {
			if (!!item["VEHID"]) {
				$("#vehicle_dropdown").append("<li><a class='veh_dropdown' data-vehid='" + item["VEHID"] + "'>" + item["VEHID"] +"</a></li>");
				if (first) {
					$("#current_vehicle_id").html(item["VEHID"] + " ");
					fuelbuddy.current_vehicle_id = item["VEHID"];
					first = false;
			    }
			}
		});
		$(".veh_dropdown").click(function() {
			$("#current_vehicle_id").html($(this).attr('data-vehid') + " ");
			fuelbuddy.current_vehicle_id = $(this).attr('data-vehid');
			fuelbuddy.updateMainFragment();
		});
		
		if (callback) {
			callback();
		}
	});
}

fuelbuddy.appOnReady = function() {
	window.onhashchange = function() {
		fuelbuddy.updateMainFragment();
	};
	
	// Initialize the loading modal
	$("#loading_modal").modal({
		backdrop: 'static',
		keyboard: false,
		show: false
	});
	
	fuelbuddy.updateGlobalSettingsAndInitApp();
}

function _ap(text) {
	$("#debugarea").append(text + "<br />");
}

fuelbuddy.remindersBehavior = function() {
	fuelbuddy.loadReminders(1);
	
	// Add handlers for the tab nav
	$("#service-reminders").click(function() {
		$("#expense-reminders").parent().removeClass("active");
		$("#service-reminders").parent().addClass("active");
		fuelbuddy.loadReminders(1);
	});

	$("#expense-reminders").click(function() {
		$("#service-reminders").parent().removeClass("active");
		$("#expense-reminders").parent().addClass("active");
		fuelbuddy.loadReminders(2);
	});
}

fuelbuddy.loadReminders = function(recType, limit) {	
	fuelbuddy.beforeCall();
	jQuery.getJSON(fuelbuddy.REMINDERS_PHP + "?vehid=" + fuelbuddy.current_vehicle_id, "", function(data) {
		var dataAdded = false;
		$("#reminders_area").empty();
		var remindersAdded = 0;
		$.each(data, function(count, item) {
			
			if (recType && item["TYPE"] != recType) {
				return;
			}
			
			// No need to show if there's no service done or there's no reminders
			
			if (item["LAST_DATE"] == 0 || (item["DUE_MILES"] == 0 && item["DUE_DAYS"] == 0)) {
				return;
			}
			
			_ap("Type: " + fuelbuddy.logTypes[item["TYPE"]] + " --- " + item["SERVICE_NAME"]);
			var maxOdo = parseFloat(item["MAX_ODO"]);
			_ap("MaxOdo: " + maxOdo.toFixed(2));
			
			var lastDate = new Date(0);
			lastDate.setTime(item["LAST_DATE"]);
			var lastDateTime = lastDate.getTime();
			var lastOdo = parseFloat(item["LAST_ODO"]);

			_ap("Last Service Done: " + fuelbuddy.getDayMonthAndYear(lastDate) + " / " + lastOdo + " " + fuelbuddy.global_settings["distance"]);

			var dueOdo = parseFloat(lastOdo) + parseFloat(item["DUE_MILES"]);
			var odoPercentage = ((maxOdo - lastOdo) / (dueOdo - lastOdo) * 100).toFixed(2);
			_ap("Due Miles: " + item["DUE_MILES"] + " Deadline: " + dueOdo.toFixed(2) + " Progress: " + odoPercentage + "%");
			
			var dueDateTime = lastDate.getTime() + (parseInt(item["DUE_DAYS"]) * 24 * 60 * 60 * 1000);
			var dueDate = new Date(0);
			dueDate.setTime(dueDateTime);
			var currentDateTime = new Date().getTime();
			var timePercentage = ((currentDateTime - lastDateTime) / (dueDateTime - lastDateTime) * 100).toFixed(2);
			_ap("Due Days: " + item["DUE_DAYS"] + " Deadline: " + fuelbuddy.getDayMonthAndYear(dueDate) + " Progress: " + timePercentage + "%");
			
			var percentage;
			var dueValue = "";
			
			if (item["DUE_MILES"] == 0) {
				_ap("Show percentage (time): " + timePercentage + "%");
				_ap("Due: " + fuelbuddy.getDayMonthAndYear(dueDate));
				dueValue = fuelbuddy.getDayMonthAndYear(dueDate);
				percentage = timePercentage;
			} else if (item["DUE_DAYS"] == 0){
				_ap("Show percentage (odo): " + odoPercentage + "%");
				_ap("Due: " + dueOdo);
				dueValue = dueOdo + " " + fuelbuddy.global_settings["distance"];
				percentage = odoPercentage;
			} else if (timePercentage > odoPercentage) {
				_ap("Show percentage (time): " + timePercentage + "%");
				_ap("Due: " + fuelbuddy.getDayMonthAndYear(dueDate) + " / " + dueOdo);
				dueValue = fuelbuddy.getDayMonthAndYear(dueDate) + " / " + dueOdo + " " + fuelbuddy.global_settings["distance"];
				percentage = timePercentage;
			} else {
				_ap("Show percentage (odo): " + odoPercentage + "%");
				_ap("Due: " + fuelbuddy.getDayMonthAndYear(dueDate) + " / " + dueOdo);
				dueValue = fuelbuddy.getDayMonthAndYear(dueDate) + " / " + dueOdo + " " + fuelbuddy.global_settings["distance"];
				percentage = odoPercentage;
			}
			
			percentage = Math.abs(percentage);
			var greenPercentage = 0;
			var yellowPercentage = 0;
			var redPercentage = 0;
			if (percentage > 33.33) {
				if (percentage > 66.66) {
					redPercentage = percentage;
				} else {
					yellowPercentage = percentage;
				}
			} else {
				greenPercentage = percentage;
			}
			
			
			var lastDateString = "Last ";
			if (item["TYPE"] == 1) {
				lastDateString += "Service: ";
			} else {
				lastDateString += "Paid On: ";
			}
			$("#reminders_area").append(($("#reminders_template").clone().html()
			    .replace("SERVICE_NAME", item["SERVICE_NAME"])
			    .replace("LAST_DATE", lastDateString + fuelbuddy.getDayMonthAndYear(lastDate) + " / " + lastOdo + " " + fuelbuddy.global_settings["distance"])
				.replace("DUE_VALUE", dueValue)
				.replace("GREEN_PERCENTAGE", greenPercentage)
				.replace("YELLOW_PERCENTAGE", yellowPercentage)
				.replace("RED_PERCENTAGE", redPercentage)));
			dataAdded = true;
			
			
			_ap("<br />");
			
			remindersAdded++;
			console.log("Comparing " + limit + " with " + count);
			if (limit && remindersAdded >= limit) {
				console.log("Exiting");
				return;
			}
		});
		
		if (!dataAdded) {
			$("#reminders_area").append("<tr><td style='text-align:center'><b>No reminders found</b></td></tr>");
		}
	})
	.always(function() {
	    fuelbuddy.afterCall();
	});
}

_b = function(time) {
	var d = new Date(0);
	d.setTime(time);
	return fuelbuddy.getDayMonthAndYear(d);
}

fuelbuddy.loadChart = function(chartFunctionName) {
	fuelbuddy.current_chart_function = chartFunctionName;
	fuelbuddy[chartFunctionName]();
}

fuelbuddy.current_chart_function = "";
fuelbuddy.current_start_date = (new Date(0)).getTime();
fuelbuddy.current_end_date = (new Date()).getTime();

fuelbuddy.dashboardBehavior = function() {
	
	fuelbuddy.current_chart_function = "";
	fuelbuddy.current_start_date = (new Date(0)).getTime();
	fuelbuddy.current_end_date = (new Date()).getTime();
	
	// Add the behavior to the date range
	$(".date-range-link").click(function() {
		var dateRange = $(this).attr('data-date-range');
		console.log("Showing " + dateRange);
		$("#current-date-range").html($(this).html());
		var start = fuelbuddy.getDateRanges()[dateRange + "Start"];
		var end = fuelbuddy.getDateRanges()[dateRange + "End"];
		fuelbuddy.current_start_date = start;
		fuelbuddy.current_end_date = end;
		console.log(_b(start) + " to " + _b(end));
		fuelbuddy.getDashboardStats(start, end);
	});
	
	
	// Add behavior to the chart links
	$(".chart-link").click(function() {
		$(".chart-link").parent().parent().removeClass("current-chart");
		$(this).parent().parent().addClass("current-chart");
		var chartFunctionName = $(this).attr('data-chart-function');
		console.log("Loading chart with function " + chartFunctionName);
		fuelbuddy.loadChart(chartFunctionName);
	});
	
	fuelbuddy.getDashboardStats(0, (new Date()).getTime());
}

fuelbuddy.showBoxStat = function(id, value) {
	try {
		if (value == "N/A" || isNaN(value)) {
			$("#" + id).html("N/A");
		} else {
			var floatVal = parseFloat(value).toFixed(2);
			if (isNaN(floatVal)) {
				$("#" + id).html("N/A");
			} else {
				$("#" + id).html(floatVal);
			}
		}
	} catch (err) {
		console.log("Error showing " + id + ": " + err.message);
		$("#" + id).html("N/A");
	}	
}

fuelbuddy.getDashboardStats = function(startDate, endDate) {
	$("#chart-body").html("<i class='fa fa-spinner fa-spin'></i>  Loading ...");
	fuelbuddy.beforeCall();
	jQuery.getJSON(fuelbuddy.DASHBOARD_STATS_PHP 
			+ "?vehid=" + fuelbuddy.current_vehicle_id
			+ "&startDate=" + startDate + "&endDate=" + endDate, "", function(data) {
		
		$.each(data, function(key, value) {
			try {
				console.log(key + " = " + value);
				if (value == "N/A") {
					$("#" + key + "-stat").html("N/A");
				} else {
					$("#" + key + "-stat").html(value.toFixed(2));
				}
			} catch(err) {
				console.log("Error showing " + key + "-stat " + err.message);
				$("#" + key + "-stat").html("N/A");
			}
		});

		// Show/calculate the box stats
		fuelbuddy.showBoxStat("avg-fuel-efficiency-box-stat", data["avg-fuel-efficiency"]);
		fuelbuddy.showBoxStat("fuel-cost-per-distance-box-stat", data["fuel-cost-per-distance"]);
		fuelbuddy.showBoxStat("tax-deduction-box-stat", data["tax-deduction"]);
		try {
			var runningCost = data["running-cost"] / data["distance"];
			fuelbuddy.showBoxStat("running-cost-box-stat", runningCost);
		} catch (err) {
			fuelbuddy.showBoxStat("running-cost-box-stat", "N/A");
		}
		
		// Add the behavior to the stats dropdown
		$(".stats-link").click(function() {
			$(".stats-table").hide();
			console.log("Showing " + $(this).attr('data-stat-name'));
			$("#current-stat-name").html($(this).html());
			$("#stats-table-name").html($(this).html());
			$("#" + $(this).attr('data-stat-name')).show();
			
			// If there is a default chart function, call it, but also
			// find out what row and highlight it
			if ($(this).attr('data-default-chart') != "") {
				var functionName = $(this).attr('data-default-chart');
				
				$(".chart-link").parent().parent().removeClass("current-chart");
				jQuery.each($(".chart-link"), function(count, item) {
					console.log(item);
					if ($(item).attr('data-chart-function') == functionName) {
						$(item).parent().parent().addClass("current-chart");
					}
				});
				
				fuelbuddy.loadChart(functionName);
			}
		});
		
		fuelbuddy.showLastFiveLogs();
		
		$("#reminders_area").html("<tr id='reminder-loading-line'><td colspan='4'><i class='fa fa-spinner fa-spin'></i>  Loading ...</td></tr>");
		fuelbuddy.loadReminders(undefined, 6);
		
		if (fuelbuddy.current_chart_function == "") {
			fuelbuddy.showAvgFuelEfficiencyChart();
		} else {
			fuelbuddy.loadChart(chartFunctionName);
		}
	})
	.always(function() {
	    fuelbuddy.afterCall();
	});
}


fuelbuddy.getAddFragment = function(logType) {
	$('#add_modal').on('shown.bs.modal', function (event) {
		$("#log_date").datepicker();
		$("#log_date").datepicker("setDate", new Date());
	});

	jQuery.get("fragments/" + fuelbuddy.editLogFragments[logType] + "?vehid=" + fuelbuddy.current_vehicle_id, "", function(data) {
		$("#add_modal_title").text("Add " + fuelbuddy.logTypes[logType]);
		$("#add_modal_body").html(data.replace("VEHICLE_ID", fuelbuddy.current_vehicle_id).replace("LOG_TYPE", logType));
		$("#add-log-error").html();
		$("#add-log-error").hide();
		
		// For fill-ups, we need to do the extra step of showing the last brand, octane and filling station
		if (logType == 0) {
			$("#fuel_brand").val(fuelbuddy.global_settings["last_brand"]);
			$("#octane").val(parseInt(fuelbuddy.global_settings["last_octane"]));
			$("#filling_station").val(fuelbuddy.global_settings["last_filling_station"]);
			fuelbuddy.addPriceAndCostHandlers();
		}
		
		$("#add-log-submit-button").html("Submit");
		$("#add_modal").modal('show');
	}, "html");
		
	$("#add-log-submit-button").unbind();
	if (logType == 0) {
		$("#add-log-submit-button").click(function() {
			fuelbuddy.addFillup();		
		});
	} else {
		$("#add-log-submit-button").click(function() {
			fuelbuddy.addLog();		
		});
	} 
};

fuelbuddy.postRequest = function (formData, url, doneFunction, failFunction) {
	var error = false;
	
	if (error) {
		$("#" + errorDivId).show();
		return false;
	} else {
		jQuery.ajax({
		    url: url,
		    data: formData,
			dataType: 'json',
		    cache: false,
		    contentType: false,
		    processData: false,
		    type: 'POST',
		})
		.done(doneFunction)
		.fail(failFunction);
	}
}

fuelbuddy.addDateToFormData = function(formData) {
	
	if ($("#log_date").val() == "") {
		$("#add-log-error").html("Please specify a valid date");
		$("#add-log-error").show();
		$("#add-log-submit-button").html("Submit");
		return false;
	}
	
	var logDate = $("#log_date").datepicker("getDate");
	formData.set("date", logDate.getTime());
	formData.set("day", logDate.getDate());
	formData.set("month", logDate.getMonth() + 1);
	formData.set("year", logDate.getFullYear());
	return true;
}

fuelbuddy.addFillup = function() {
	
	var formData = new FormData();
	jQuery.each($("#add_log_form").serializeArray(), function(count, data) {formData.append(data["name"], data["value"]);});
	jQuery.each(jQuery('#img_file')[0].files, function(i, file) {
	    formData.append('img_file', file);
		formData.append('receipt', file.name);
	});

	formData.set("source", "web");
	formData.set("vehid", fuelbuddy.current_vehicle_id);
	formData.set("type", "add");
	formData.set("email", fuelbuddy.current_user_email);
	if (!fuelbuddy.addDateToFormData(formData)) {
		return;
	}
	formData.set("pfill", $("#pfill").prop("checked") ? 1 : 0);
	formData.set("mfill", $("#mfill").prop("checked") ? 1 : 0);
	formData.set("serviceType", "Fuel Record");
	
	if (!fuelbuddy.validateOdo()) {
		return;
	}
	if (!fuelbuddy.validateQty()) {
		return;
	}
	
	$("#add-log-submit-button").html("<i class='fa fa-spinner fa-spin'> </i>  ");
	
	fuelbuddy.validateOdoAndDate($("#odo").val(), formData.get("date"), function() {
		fuelbuddy.postRequest(formData, fuelbuddy.LOGS_UPDATE_PHP,
			function(response) {
				if (response['success'] == 0) {
					$("#add-log-error").html(response['message']);
					$("#add-log-error").show();
					$("#add-log-submit-button").html("Submit");
				} else {
					$("#add_modal").modal('hide');
			
					// Need the next two lines because otherwise the modal stays open. 
					// Copied from http://stackoverflow.com/questions/11519660/twitter-bootstrap-modal-backdrop-doesnt-disappear
					$('body').removeClass('modal-open');
					$('.modal-backdrop').remove();

					fuelbuddy.updateGlobalSettings(true, fuelbuddy.updateMainFragment);
				}
			 },
			 function(response) {
				$("#add-log-error").html("An error occured on the server. Please re-try this operation or contact support.");
				$("#add-log-error").show();
				$("#add-log-submit-button").html("Submit");
			 });
		 }
	 );
}

fuelbuddy.validateOdo = function() {
	if ($("#odo").val() == "" || isNaN($("#odo").val())) {
		$("#add-log-error").html("Please enter a valid odometer value");
		$("#add-log-error").show();
		return false;
	}
	return true;
}

fuelbuddy.validateQty = function() {
	if ($("#qty").val() == "" || isNaN($("#qty").val())) {
		$("#add-log-error").html("Please enter a valid quantity");
		$("#add-log-error").show();
		return false;
	}
	return true;
}

fuelbuddy.addLog = function() {
	
	$("#add-log-submit-button").html("<i class='fa fa-spinner fa-spin'> </i>  ");
	
	var formData = new FormData();
	jQuery.each($("#add_log_form").serializeArray(), function(count, data) {formData.append(data["name"], data["value"]);});
	jQuery.each(jQuery('#img_file')[0].files, function(i, file) {
	    formData.append('img_file', file);
		formData.append('receipt', file.name);
	});

	formData.set("source", "web");
	formData.set("vehid", fuelbuddy.current_vehicle_id);
	formData.set("type", "add");
	formData.set("email", fuelbuddy.current_user_email);
	formData.set("serviceType", $("#service_type").val().join(","));
	if (!fuelbuddy.addDateToFormData(formData)) {
		return;
	}
	
	if (!fuelbuddy.validateOdo()) {
		return;
	}
	
	fuelbuddy.validateOdoAndDate($("#odo").val(), formData.get("date"), function() {
		fuelbuddy.postRequest(formData, fuelbuddy.LOGS_UPDATE_PHP,
			function(response) {
				if (response['success'] == 0) {
					$("#add-log-submit-button").html("Submit");
					$("#add-log-error").html(response['message']);
					$("#add-log-error").show();
					$("#add-log-submit-button").html("Submit");
				} else {
					$("#add_modal").modal('hide');
			
					// Need the next two lines because otherwise the modal stays open. 
					// Copied from http://stackoverflow.com/questions/11519660/twitter-bootstrap-modal-backdrop-doesnt-disappear
					$('body').removeClass('modal-open');
					$('.modal-backdrop').remove();

					fuelbuddy.updateMainFragment();	
				}
			 },
			 function(response) {
				$("#add-log-submit-button").html("Submit");
				$("#add-log-error").html("An error occured on the server. Please re-try this operation or contact support.");
				$("#add-log-error").show();
				$("#add-log-submit-button").html("Submit");				
			 });
		 }
	 );
}

fuelbuddy.editLog = function() {
	
	$("#add-log-submit-button").html("&nbsp;&nbsp;&nbsp;<i class='fa fa-spinner fa-spin'></i>&nbsp;&nbsp;&nbsp;")
	
	var formData = new FormData();
	jQuery.each(jQuery('#img_file')[0].files, function(i, file) {
	    formData.append('img_file', file);
		formData.append('receipt', file.name);
	});
	formData.set("source", "web");
	formData.set("_id", $("#logId").val());
	formData.set("vehid", fuelbuddy.current_vehicle_id);
	formData.set("type", "edit");
	formData.set("email", fuelbuddy.current_user_email);

	jQuery.each($("#add_log_form").serializeArray(), function(count, data) {formData.append(data["name"], data["value"]);});
	formData.set("serviceType", $("#service_type").val().join(","));
	if (!fuelbuddy.addDateToFormData(formData)) {
		return;
	}
	
	if (!fuelbuddy.validateOdo()) {
		return;
	}
	
	fuelbuddy.validateOdoAndDate($("#odo").val(), formData.get("date"), function() {
		fuelbuddy.postRequest(formData, fuelbuddy.LOGS_UPDATE_PHP,
			function(response) {
				if (response['success'] == 0) {
					$("#add-log-submit-button").html("Submit");
					$("#add-log-error").html(response['message']);
					$("#add-log-error").show();
					$("#add-log-submit-button").html("Submit");
				} else {
					$("#add_modal").modal('hide');
			
					// Need the next two lines because otherwise the modal stays open. 
					// Copied from http://stackoverflow.com/questions/11519660/twitter-bootstrap-modal-backdrop-doesnt-disappear
					$('body').removeClass('modal-open');
					$('.modal-backdrop').remove();

					fuelbuddy.updateMainFragment();	
				}
			 },
			 function(response) {
				$("#add-log-submit-button").html("Submit");
				$("#add-log-error").html("An error occured on the server. Please re-try this operation or contact support.");
				$("#add-log-error").show();
				$("#add-log-submit-button").html("Submit");
			 });
		 }
	 );
}

fuelbuddy.taxDeducted = function() {
	try {
		var taxDeducted = (parseFloat($("#tax_deduction_rate").val()) * (parseFloat($("#end_odo").val()) - parseFloat($("#start_odo").val())) / 100) 
			+ parseFloat($("#parking").val()) + parseFloat($("#toll").val());
		if (isNaN(taxDeducted)) {
			return "N/A";
		}
		return taxDeducted;
	} catch (err) {
		return "N/A"
	}
}

fuelbuddy.editTrip = function() {
	
	$("#add-log-submit-button").html("&nbsp;&nbsp;&nbsp;<i class='fa fa-spinner fa-spin'></i>&nbsp;&nbsp;&nbsp;")
	
	var formData = new FormData();
	jQuery.each(jQuery('#img_file')[0].files, function(i, file) {
	    formData.append('img_file', file);
		formData.append('receipt', file.name);
	});
	formData.set("source", "web");
	formData.set("_id", $("#logId").val());
	formData.set("vehid", fuelbuddy.current_vehicle_id);
	formData.set("type", "edit");
	formData.set("rec_type", "3");
	formData.set("email", fuelbuddy.current_user_email);
	
	// Translate the overloaded columns!
	
	var startDate = $("#start_date").datepicker("getDate");
	var startHour = parseInt($("#start_hour").val());
	var startMin = parseInt($("#start_min").val());
	if ($("#start_ampm").val() == "PM") {
		startDate.setHours(startHour + 12);
		formData.set("pfill", startHour + 12);
	} else {
		startDate.setHours(startHour);
		formData.set("pfill", startHour);
	}
	startDate.setMinutes(startMin);
	formData.set("mfill", startMin);
	
	formData.set("date", startDate.getTime());
	formData.set("day", startDate.getDate());
	formData.set("month", startDate.getMonth() + 1);
	formData.set("year", startDate.getFullYear());
	
	
	var endHour = parseInt($("#end_hour").val());
	var endMin = parseInt($("#end_min").val());
	var endDate = $("#end_date").datepicker("getDate");
	if ($("#end_ampm").val() == "PM") {
		endDate.setHours(endHour + 12);
	} else {
		endDate.setHours(endHour);
	}
	endDate.setMinutes(endMin);
	formData.set("cons", endDate.getTime());
	
	formData.set("odo", $("#start_odo").val());
	formData.set("qty", $("#end_odo").val());

	formData.set("fuelBrand", $("#start_loc").val());
	formData.set("fillStation", $("#end_loc").val());
	
	formData.set("dist", $("#parking").val());
	formData.set("octane", $("#toll").val());
	
	var taxDeducted = fuelbuddy.taxDeducted();
	formData.set("cost", taxDeducted);
	
	formData.set("serviceType", $("#trip_type").val());
	
	formData.set("notes", $("#notes").val());
	
	for (var pair of formData.entries()) {
	    console.log(pair[0]+ ' = ' + pair[1]); 
	}
	
	fuelbuddy.validateOdoAndDate($("#odo").val(), formData.get("date"), function() {
		fuelbuddy.postRequest(formData, fuelbuddy.LOGS_UPDATE_PHP,
			function(response) {
				if (response['success'] == 0) {
					$("#add-log-error").html(response['message']);
					$("#add-log-error").show();
					$("#add-log-submit-button").html("Submit");
				} else {
					$("#add_modal").modal('hide');
			
					// Need the next two lines because otherwise the modal stays open. 
					// Copied from http://stackoverflow.com/questions/11519660/twitter-bootstrap-modal-backdrop-doesnt-disappear
					$('body').removeClass('modal-open');
					$('.modal-backdrop').remove();

					fuelbuddy.updateMainFragment();	
				}
			 },
			 function(response) {
				$("#add-log-error").html("An error occured on the server. Please re-try this operation or contact support.");
				$("#add-log-error").show();
				$("#add-log-submit-button").html("Submit");
			 });
		 }
	 );
}

fuelbuddy.editFillup = function() {
	
	$("#add-log-submit-button").html("&nbsp;&nbsp;&nbsp;<i class='fa fa-spinner fa-spin'></i>&nbsp;&nbsp;&nbsp;")
	
	var formData = new FormData();
	jQuery.each($("#add_log_form").serializeArray(), function(count, data) {formData.append(data["name"], data["value"]);});
	jQuery.each(jQuery('#img_file')[0].files, function(i, file) {
	    formData.append('img_file', file);
		formData.append('receipt', file.name);
	});
	
	formData.set("source", "web");
	formData.set("_id", $("#logId").val());
	formData.set("vehid", fuelbuddy.current_vehicle_id);
	formData.set("type", "edit");
	formData.set("email", fuelbuddy.current_user_email);
	formData.set("serviceType", "Fuel Record");
	formData.set("pfill", $("#pfill").prop("checked") ? 1 : 0);
	formData.set("mfill", $("#mfill").prop("checked") ? 1 : 0);
	if (!fuelbuddy.addDateToFormData(formData)) {
		return;
	}
	
	if (!fuelbuddy.validateOdo()) {
		return;
	}
	if (!fuelbuddy.validateQty()) {
		return;
	}
	
	fuelbuddy.validateOdoAndDate($("#odo").val(), formData.get("date"), function() {
		fuelbuddy.postRequest(formData, fuelbuddy.LOGS_UPDATE_PHP,
			function(response) {
				if (response['success'] == 0) {
					$("#add-log-error").html(response['message']);
					$("#add-log-error").show();
					$("#add-log-submit-button").html("Submit");
				} else {
					$("#add_modal").modal('hide');
			
					// Need the next two lines because otherwise the modal stays open. 
					// Copied from http://stackoverflow.com/questions/11519660/twitter-bootstrap-modal-backdrop-doesnt-disappear
					$('body').removeClass('modal-open');
					$('.modal-backdrop').remove();

					fuelbuddy.updateGlobalSettings(true, fuelbuddy.updateMainFragment);	
				}
			 },
			 function(response) {
				$("#add-log-error").html("An error occured on the server. Please re-try this operation or contact support.");
				$("#add-log-error").show();
				$("#add-log-submit-button").html("Submit");
			 });
		 }
	 );
}

fuelbuddy.padTwoZero = function(str) {
  str = str.toString();
  return str.length < 2 ? fuelbuddy.padTwoZero("0" + str, 2) : str;
}

fuelbuddy.updateTripFragment = function(logData) {
	var startDate = new Date(0);
	startDate.setUTCMilliseconds(logData["DATE"]);
	console.log(startDate);
	$("#start_date").datepicker();
	$("#start_date").datepicker("setDate", startDate);
	$("#start_hour").val((startDate.getHours() > 12) ? fuelbuddy.padTwoZero(startDate.getHours() - 12) : fuelbuddy.padTwoZero(startDate.getHours()));
	$("#start_min").val(fuelbuddy.padTwoZero(startDate.getMinutes()));
	$("#start_ampm").val(startDate.getHours() > 12 ? "PM" : "AM");
	$("#start_odo").val(logData["ODO"]);
	$("#start_loc").val(logData["FUEL_BRAND"]);
	
	var endDate = new Date(0);
	endDate.setUTCMilliseconds(logData["CONSUMPTION"]);
	console.log(endDate);
	$("#end_date").datepicker();
	$("#end_date").datepicker("setDate", endDate);
	$("#end_hour").val((endDate.getHours() > 12) ? fuelbuddy.padTwoZero(endDate.getHours() - 12) : fuelbuddy.padTwoZero(endDate.getHours()));
	$("#end_min").val(fuelbuddy.padTwoZero(endDate.getMinutes()));
	$("#end_ampm").val(endDate.getHours() > 12 ? "PM" : "AM");
	$("#end_odo").val(logData["QTY"]);
	$("#end_loc").val(logData["FILLING_STATION"]);
	
	// We need to reverse calculate the tax deduction rate from the cost
	var tax = parseFloat(logData["COST"]) - parseFloat(logData["DIST"]) - parseFloat(logData["OCTANE"]);
	var taxRate = 100 * tax / (parseFloat(logData["QTY"]) - parseFloat(logData["ODO"]));
	$("#total-tax").val(tax);
	$("#tax_deduction_rate").val(taxRate.toFixed(2));
	
	$("#parking").val(logData["DIST"]);
	$("#toll").val(logData["OCTANE"]);
	$("#notes").val(logData["NOTES"]);
	
	$("#trip_type").val(logData["SERVICE_TYPE"]);

	$(".calculate-tax-deducted").off("keypress");
	$(".calculate-tax-deducted").keypress(function() {
		$("#total-tax").val(fuelbuddy.taxDeducted());
	});
}

fuelbuddy.addPriceAndCostHandlers = function() {
	// For fill-ups, add the required handlers for cost and price/ltr
	$(".update-cost").off("change");
	$(".update-cost").off("keypress");
	$(".update-cost").off("keyup");
	
	$("#price").keyup(function() {
		if ($("#price").val() != "") {
			$("#cost").val(parseFloat($("#price").val()) * parseFloat($("#qty").val()));
		}
	});

	$("#qty").keyup(function() {
		if ($("#price").val() != "") {
			$("#cost").val(parseFloat($("#price").val()) * parseFloat($("#qty").val()));
		}
	});

	$("#cost").keypress(function() {
		$("#price").val("");					
	});
}

fuelbuddy.getEditFragment = function(logId, logType) {
	
	fuelbuddy.beforeCall();
	jQuery.get("fragments/" + fuelbuddy.editLogFragments[logType] + "?vehid=" + fuelbuddy.current_vehicle_id, "", function(data) {
		$("#add_modal_title").text("Edit " + fuelbuddy.logTypes[logType]);
		$("#add_modal_body").html(data);
		$("#add-log-error").html();
		$("#add-log-error").hide();
		
		var query = "?vehid=" + fuelbuddy.current_vehicle_id + "&logId=" + logId;
		jQuery.getJSON(fuelbuddy.LOGS_PHP + query, "", function(data) {
			$.each(data, function(index, item) {
				if (logId == item["_ID"]) {
					console.log("Loading log: " + JSON.stringify(item));
					
					// Trips is really complicated because of the overloaded column names. Call a separate function
					// for that
					
					if (logType == 3) {
						$("#logId").val(item["_ID"]);
						fuelbuddy.updateTripFragment(item);
					} else {
						var elements = ["odo", "filling_station", "cost", "notes", "qty", "octane", "fuel_brand"];
						jQuery.each(elements, function(i, formItem) {
							if (formItem.toUpperCase() == "OCTANE") {
								$("#" + formItem).val(parseInt(item[formItem.toUpperCase()]));
							} else {
								$("#" + formItem).val(item[formItem.toUpperCase()]);
							}
						});
						$("#logId").val(item["_ID"]);
						var tmpDate = new Date(0);
						tmpDate.setUTCMilliseconds(item["DATE"]);
						$("#log_date").datepicker();
						$("#log_date").datepicker("setDate", tmpDate);
					
						// Special things for the fillups or logs
						if (logType == 0) {
							$("#service_type").val("Fuel Record");
							$("#mfill").prop("checked", (item["MISSED_FILL"] == 1));
							$("#pfill").prop("checked", (item["PARTIAL_FILL"] == 1));
							fuelbuddy.addPriceAndCostHandlers();
							$("#price").val(parseFloat($("#cost").val() / $("#qty").val()).toFixed(2));
						} else if (logType == 1 || logType == 2) {
							$("#service_type").val(("" + item["SERVICE_TYPE"]).split(","));
						}
					}
				}
				
				console.log(item["RECEIPT"]);
				if (item["RECEIPT"] && item["RECEIPT"] != "null") {
					$("#current_receipt_link").prop('href', fuelbuddy.RECEIPTS_PREFIX + item["RECEIPT"]);
					$("#current_receipt_image").prop('src', fuelbuddy.RECEIPTS_PREFIX + item["RECEIPT"]);
					$("#current_receipt").show();
				} else {
					$("#current_receipt").hide();
				}
			});
			
			$("#add-log-submit-button").html("Submit");
			
			// Everything is filled in. Now hide the loading modal and show the actual form modal.
			// We need to do this as part of the hidden.bs.modal event of the loading modal because
			// otherwise the quick transitions mess things up and when the edit page is loaded,
			// the background page scrolls with the mouse wheel.
			$('#loading_modal').on('hidden.bs.modal', function (e) {
				$("#add_modal").modal('show');
				$('#loading_modal').off('hidden.bs.modal');
			});
			fuelbuddy.afterCall();
		});
		
	}, "html");
	
	$("#add-log-submit-button").unbind();
	if (logType == 1 || logType == 2) {
		$("#add-log-submit-button").click(function() {
			fuelbuddy.editLog();		
		});
	} else if (logType == 3){
		$("#add-log-submit-button").click(function() {
			fuelbuddy.editTrip();		
		});
	} else {
		$("#add-log-submit-button").click(function() {
			fuelbuddy.editFillup();		
		});
	}
};

fuelbuddy.confirmLogDelete = function(logId) {
	var formData = new FormData();
	formData.set("source", "web");
	formData.set("_id", logId);
	formData.set("type", "del");
	formData.set("email", fuelbuddy.current_user_email);
	
	if (confirm("Are you sure you want to delete this log ?")) {
		fuelbuddy.postRequest(formData, fuelbuddy.LOGS_UPDATE_PHP,
		    function(response){
				if (0 == response['success']) {
					// TODO: Where do we show the error during deletes ??
				} else {
					fuelbuddy.updateMainFragment();
				}
		    },
	   		function(response) {
					// TODO: Where do we show the error during deletes ??
	   		});
	}
}

String.prototype.trunc = function(n) {
  return this.substr(0, n-1) + (this.length > n ? '&hellip;' : '');
};

fuelbuddy.loadLogTable = function(tableId, fields, data, applySearch, forDashboard) {
	applySearch = !forDashboard && (applySearch || false);
	
	if (forDashboard) {
		$('#' + tableId + " tbody").empty();
	}
	var rows = '';
	var dataAdded = false;
	fuelbuddy.maxValues = {"date": new Date("1000-01-01"), "odometer": "0"};
	$.each(data, function(index, item) {
		if (!!item["_ID"]) {
			
			if (applySearch && !forDashboard) {
				if ($("#odometer_search_input").val() != "") {
					switch ($("#odometer_search_dropdown").val()) {
						case "gt": if (item["ODO"] <=  $("#odometer_search_input").val()) return true; break;
						case "lt": if (item["ODO"] >=  $("#odometer_search_input").val()) return true; break;
						case "eq": if (item["ODO"] !=  $("#odometer_search_input").val()) return true; break;
					}
				}
				
				if ($("#service_type_search_dropdown").val() != "") {
					if ($("#service_type_search_dropdown").val() != item["TYPE"]) {
						return true;
					}
				}
				
				if ($("#search_date_picker").val() != "") {
					var d = new Date($("#search_date_picker").val());
					var searchDateEpoch = d.getTime();
					var searchDateString = ("0" + d.getDate()).slice(-2) + "-" + ("0"+(d.getMonth()+1)).slice(-2) + "-" + d.getFullYear();
					var itemDate = ("0" + item["DAY"]).slice(-2)  + "-" + ("0"+(item["MONTH"])).slice(-2) + "-" + item["YEAR"];
					console.log("Comparing " + searchDateString + " with " + itemDate);
					switch ($("#date_search_dropdown").val()) {
						case "gt": if (item["DATE"] <=  searchDateEpoch) return true; break;
						case "lt": if (item["DATE"] >=  searchDateEpoch) return true; break;
						case "eq": if (searchDateString != itemDate) return true; break;
					}
				}
				
				var searchText = $("#search_logs_input").val();
				if (searchText != "") {
					if (!item["NOTES"] || !item["NOTES"].match(searchText)) return true;
				}
			}
			
			var row = '<tr>';
			row += '<td class="col-sm-1">' + '<img height="40" width="40" src="' + fuelbuddy.serviceTypeIcons[item["TYPE"]] + '"></td>';
			
			var costString = (item["COST"] == "" || item["COST"] == null || item["COST"] == 0)
				? "" : fuelbuddy.global_settings["currency"] + " " + item["COST"];
			
			if (item["TYPE"] == 0) {
				var pfill = item["PARTIAL_FILL"] == "1" ? " (P) " : "";
				var consumption  = item["CONSUMPTION"] == null || item["CONSUMPTION"] == 0
					? "N/A" : item["CONSUMPTION"] + " " + fuelbuddy.global_settings["consumption"];
				row += '<td>' + item["MONTH"] + "/" + item["DAY"] + "/" + item["YEAR"];
				if (!forDashboard) {
					row += "<br /><small>Odo: " + item["ODO"] + " " + fuelbuddy.global_settings["distance"]  + "</small></td>";
				}
				row += '<td>' + item["QTY"] + " " + fuelbuddy.global_settings["volume"] + pfill + "<br />";
				if (!forDashboard) {
					if (item["MISSED_FILL"] == "1") {
						row += "<small>Missed Fill Up</small></td>";
					} else {
						row += "<small>(" + item["DIST"] + ")" + " " + fuelbuddy.global_settings["distance"] + "</small></td>";
					}
				}
				row += '<td>' + costString + "<br />";
				if (!forDashboard) {
					row += "<small>" + consumption + "</small></td>";
				}
			} else if (item["TYPE"] == 3) {
				var distance = (parseFloat(item["QTY"]) - parseFloat(item["ODO"])).toFixed(2);
				row += '<td>' + item["MONTH"] + "/" + item["DAY"] + "/" + item["YEAR"] + "</td>";
				row += '<td>' + item["SERVICE_TYPE"].replace(/,/g, ", ");
				if (!forDashboard) {
					row += "<br /><small>" + distance + " " + fuelbuddy.global_settings["distance"]  + "</small></td>";
				}
				row += '<td>' + costString + "</td>"
			} else {
				row += '<td>' + item["MONTH"] + "/" + item["DAY"] + "/" + item["YEAR"];
				if (!forDashboard) {
					row += "<br /><small>Odo: " + item["ODO"] + " " + fuelbuddy.global_settings["distance"]  + "</small></td>";
				}
				row += '<td title="' + item["SERVICE_TYPE"].replace(/,/g, ", ") + '">' + item["SERVICE_TYPE"].replace(/,/g, ", ").trunc(25);
				if (!forDashboard) { 
					row += "<br /><small>" + item["FILLING_STATION"] + "</small>";
				}
				row += '<td>' + costString + "</td>"
			}
			
			if (!forDashboard) {
				var odometer = item["ODO"];
				var date = new Date(item["YEAR"] + "-" + item["MONTH"] + "-" + item["DAY"]);
				if (odometer > fuelbuddy.maxValues["odometer"]) {
					fuelbuddy.maxValues["odometer"] = odometer;
				}
				if (date > fuelbuddy.maxValues["date"]) {
					fuelbuddy.maxValues["date"] = date;
				}
			
				row += '<td>' + fuelbuddy.getEditButton(item["TYPE"], item["_ID"]) + ' ' + fuelbuddy.getDeleteButton(item["_ID"]) + '</td>';
			}
			rows += row + '</tr>';
			dataAdded = true;
		}
	});
	
	if (!dataAdded) {
		rows = "<tr><td style='text-align:center' colspan='5'><b>No matching data found</b></td></tr>";
	}
	
	if (forDashboard) {
		$('#' + tableId + " tbody").append(rows);
	} else {
		$('#' + tableId + " tbody").append(rows);

		// Attach behavior to all the edit buttons
		$(".edit-log-button").click(function() {
			fuelbuddy.getEditFragment($(this).attr('data-logid'), $(this).attr('data-logtype'));
		});

		// Attach behavior to all the delete buttons
		$(".delete-log-button").click(function() {
			fuelbuddy.confirmLogDelete($(this).attr('data-logid'));
		});
	}
}

fuelbuddy.getInfoButton = function(logType, logId) {
	return '<a class="info-log-button btn btn-primary" data-logtype="' + logType + '" data-logid="' + logId + '" aria-label="Edit">' +
	'<i class="fa fa-info" aria-hidden="true"></i></a>';
}

fuelbuddy.getEditButton = function(logType, logId) {
	return '<a class="edit-log-button btn btn-primary" data-logtype="' + logType + '" data-logid="' + logId + '" aria-label="Edit">' +
	'<i class="fa fa-pencil" aria-hidden="true"></i></a>';
}

fuelbuddy.getDeleteButton = function(logId) {
	return '<a class="delete-log-button btn btn-danger" data-logid="' + logId + '" aria-label="Delete">' +
	'<i class="fa fa-trash-o" aria-hidden="true"></i></a>';
}

fuelbuddy.getAddVehicleFragment = function() {
	
	jQuery.get("fragments/add_vehicle_fragment.html", "", function(data) {
		$("#veh_modal_title").text("Add Vehicle");
		$("#veh_modal_body").html(data);
		
		$("#type").val("add");
		
		$("#veh_modal").modal('show');
	}, "html");
	
	$("#add-vehicle-submit-button").unbind();
	$("#add-vehicle-submit-button").click(function() {
		fuelbuddy.addVehicle();		
	});
};

fuelbuddy.getEditVehicleFragment = function(vehId) {
	
	fuelbuddy.beforeCall();
	jQuery.get("fragments/add_vehicle_fragment.html", "", function(data) {
		$("#veh_modal_title").text("Edit Vehicle");
		$("#veh_modal_body").html(data);
		
		jQuery.getJSON(fuelbuddy.VEH_READ_PHP + "?vehId=" + vehId, "", function(data) {
			var first = true;
			$.each(data, function(index, item) {
				if (vehId === item["VEHID"]) {
					var elements = ["_id", "make", "model", "year", "lic", "year", "vin", "insurance_no", "notes"];
					jQuery.each(elements, function(i, formItem) {
						$("#" + formItem).val(item[formItem.toUpperCase()]);
					});
				}
			});
			// Everything is filled in. Now hide the loading modal and show the actual form modal.
			// We need to do this as part of the hidden.bs.modal event of the loading modal because
			// otherwise the quick transitions mess things up and when the edit page is loaded,
			// the background page scrolls with the mouse wheel.
			$('#loading_modal').on('hidden.bs.modal', function (e) {
				$("#veh_modal").modal('show');
				$('#loading_modal').off('hidden.bs.modal');
			});
			fuelbuddy.afterCall();
		});
	}, "html");	

	$("#add-vehicle-submit-button").unbind();
	$("#add-vehicle-submit-button").click(function() {
		fuelbuddy.editVehicle();		
	});
};

fuelbuddy.vehiclesBehavior = function() {
	
	// Fetch the vehicles and add them as the base template after replacing the place holders
	$("#vehicles_area").empty();
	fuelbuddy.vehIds = []
	
	fuelbuddy.beforeCall();
	jQuery.getJSON(fuelbuddy.VEH_READ_PHP, "", function(data) {
		var first = true;
		$.each(data, function(index, item) {
			if (!!item["VEHID"]) {
				var picture = (item["PICTURE"] == null || item["PICTURE"] == "") 
					? "no_image_sq.png" : item["PICTURE"];
				
				$("#vehicles_area").append(
					$("#vehicle_template").clone().removeClass("template").html()
						.replace("VEHICLE_NAME", item["VEHID"])
						.replace("VEHICLE_ID", item["VEHID"])
						.replace("VEHICLE_ID", item["VEHID"])
					    .replace("VEHICLE_URL", fuelbuddy.IMAGES_PREFIX + picture)
     					.replace("_ID", item["_ID"]));
				fuelbuddy.vehIds.push(item["VEHID"]);
			}
		});
	
		// Remove the base template from the DOM
		$("#vehicle_template").remove();
		
		// Attach behavior to all the buttons
		
	    $("#add-veh-button").click(function() {
	    	fuelbuddy.getAddVehicleFragment();
	    });
		
		$(".delete-veh-button").click(function() {
			if (confirm('Are you sure you want to delete this vehicle ? ')) {
				fuelbuddy.deleteVehicle($(this).attr('data-id'));
			};
		});

		$(".edit-veh-button").click(function() {
			fuelbuddy.getEditVehicleFragment($(this).attr('data-vehid'));
		});
	})
	.always(function() {
	    fuelbuddy.afterCall();
	});
}

fuelbuddy.isEmpty = function(str) {
    return (!str || 0 === str.length);
}

fuelbuddy.deleteVehicle = function(vehicleId) {
	var formData = new FormData();
	formData.set("source", "web");
	formData.set("type", "del");
	formData.set("email", fuelbuddy.current_user_email);
	formData.set("_id", vehicleId);
	fuelbuddy.postRequest(formData, fuelbuddy.VEH_UPDATE_PHP, 
	    function(response){
			if (0 == response['success']) {
				// TODO: Where do we show the error during deletes ??
			} else {
				fuelbuddy.updateVehicleDropdown(fuelbuddy.updateMainFragment);
			}
	    },
   		function(response) {
				// TODO: Where do we show the error during deletes ??
   		}
	);
}

fuelbuddy.addVehicle = function() {
	
	var formData = new FormData();
	formData.set("source", "web");
	
	jQuery.each($("#add_vehicle_form").serializeArray(), function(count, data) {formData.append(data["name"], data["value"]);});
	jQuery.each(jQuery('#img_file')[0].files, function(i, file) {
	    formData.append('img_file', file);
		formData.append('picture', file.name);
	});
	
	var error = false;
	if (!formData.get("make") && !formData.get("model")) {
		$("#add-vehicle-error").html("Please enter at least one of make or model");
		error = true;
	} else if (fuelbuddy.vehIds.indexOf(formData.get("make") + " " + formData.get("model")) > -1) {
		$("#add-vehicle-error").html("A vehicle already exists with the same make and model");
		error = true;
	}
	
	if (error) {
		$("#add-vehicle-error").show();
		return false;
	} else {
		
		$("#add-vehicle-submit-button").html("<i class='fa fa-spinner fa-spin'> </i>  ");
		
		formData.set("type", "add");
		formData.set("vehid", (formData.get("make") + " " + formData.get("model")).trim());
		formData.set("email", fuelbuddy.current_user_email);
		fuelbuddy.postRequest(formData, fuelbuddy.VEH_UPDATE_PHP, 
		    function(response){
				if (0 == response['success']) {
					$("#add-vehicle-error").html(response['message']);
					$("#add-vehicle-error").show();
					$("#add-vehicle-submit-button").html("Submit");
				} else {
					$("#veh_modal").modal('hide');
				
					// Need the next two lines because otherwise the modal stays open. 
					// Copied from http://stackoverflow.com/questions/11519660/twitter-bootstrap-modal-backdrop-doesnt-disappear
					$('body').removeClass('modal-open');
					$('.modal-backdrop').remove();

					fuelbuddy.updateMainFragment();	
					fuelbuddy.updateVehicleDropdown();
				}
		    },
	   		function(response) {
	   			$("#add-vehicle-error").html("An error occured on the server. Please re-try this operation or contact support.");
	   			$("#add-vehicle-error").show();
				$("#add-vehicle-submit-button").html("Submit");
	   		}
		);
	}
}

fuelbuddy.editVehicle = function() {
	
	var formData = new FormData();
	formData.set("source", "web");
	jQuery.each($("#add_vehicle_form").serializeArray(), function(count, data) {formData.append(data["name"], data["value"]);});
	jQuery.each(jQuery('#img_file')[0].files, function(i, file) {
	    formData.append('img_file', file);
		formData.append('picture', file.name);
	});
	
	var error = false;
	if (!formData.get("make") && !formData.get("model")) {
		$("#add-vehicle-error").html("Please enter at least one of make or model");
		error = true;
	}
	
	if (error) {
		$("#add-vehicle-error").show();
		return false;
	} else {
		
		$("#add-vehicle-submit-button").html("<i class='fa fa-spinner fa-spin'> </i>  ");
		
		formData.set("type", "edit");
		formData.set("vehid", (formData.get("make") + " " + formData.get("model")).trim());
		formData.set("email", fuelbuddy.current_user_email);
		fuelbuddy.postRequest(formData, fuelbuddy.VEH_UPDATE_PHP, 
		    function(response){
				if (0 == response['success']) {
					$("#add-vehicle-error").html(response['message']);
					$("#add-vehicle-error").show();
					$("#add-vehicle-submit-button").html("Submit");
				} else {
					$("#veh_modal").modal('hide');
			
					// Need the next two lines because otherwise the modal stays open. 
					// Copied from http://stackoverflow.com/questions/11519660/twitter-bootstrap-modal-backdrop-doesnt-disappear
					$('body').removeClass('modal-open');
					$('.modal-backdrop').remove();

					fuelbuddy.updateMainFragment();	
					fuelbuddy.updateVehicleDropdown();
				}
		    },
	   		function(response) {
	   			$("#add-vehicle-error").html("An error occured on the server. Please re-try this operation or contact support.");
	   			$("#add-vehicle-error").show();
				$("#add-vehicle-submit-button").html("Submit");
	   		}
		);
	}
}

fuelbuddy.logBehavior = function() {
	
	// Intialize the date picker in the search box
	$("#search_date_picker").datepicker(); //{format: 'mm-dd-yyyy'}).datepicker('setValue', new Date());
	$("#search_date_picker").val("");
	
	// Attach behavior to the search dropdown to add distance for fillups and trips
	$("#service_type_search_dropdown").off("change");
	$("#service_type_search_dropdown").change(function() {
		$("#search_sort option[value='dist']").remove();
		if ($("#service_type_search_dropdown").val() == 0 || $("#service_type_search_dropdown").val() == 3) {
			$('#search_sort').append($('<option>', {
			    value: "dist",
			    text: "Distance"
			}));
		}
	});
	
    // Attach behavior to the add log button
    $(".add-log-button").click(function() {
    	fuelbuddy.getAddFragment($(this).attr('data-logtype'));
    });

    fuelbuddy.beforeCall();
    // Get the logs and load the table	
	jQuery.getJSON(fuelbuddy.LOGS_PHP + "?" + 'vehid=' + fuelbuddy.current_vehicle_id, "", function(data) {
		// Attach toggle behavior to the search button
		$("#search_btn").click(function() {
			$("#search_box").toggle();
			if ($("#search_box").is(":visible")) {
				$("#search_btn").html("Hide");
			} else {
				$("#search_btn").html("Filter");
			}
			
		});
		
		// Attach search behavior to the apply and reset buttons
		$("#do_search_btn").click(function() {
			fuelbuddy.searchLogs();
		});
		
		$("#reset_search_btn").click(function() {
			fuelbuddy.resetSearchLogs();
		});
		
		fuelbuddy.loadLogTable("logs_table", "", data, false);
	})
	.always(function() {
	    fuelbuddy.afterCall();
	});
}

fuelbuddy.showLastFiveLogs = function() {
    // Get the logs and load the table	
	
	$("#mini-logs-table").append("<tr id='log-loading-line'><td colspan='4'><i class='fa fa-spinner fa-spin'></i>  Loading ...</td></tr>");
	
	jQuery.getJSON(fuelbuddy.LOGS_PHP + "?limit=5&" + 'vehid=' + fuelbuddy.current_vehicle_id, "", function(data) {
		$("#log-loading-line").remove();
		fuelbuddy.loadLogTable("mini-logs-table", "", data, false, true);
	})
}

fuelbuddy.searchLogs = function() {
    // Get the logs and load the table	
	$("#logs_table tbody").empty();
	fuelbuddy.beforeCall();
	jQuery.getJSON(fuelbuddy.LOGS_PHP + "?" + 'vehid=' + fuelbuddy.current_vehicle_id + "&sortBy=" + $("#search_sort").val(), "", function(data) {
		fuelbuddy.loadLogTable("logs_table", "", data, true);
	})
	.always(function() {
	    fuelbuddy.afterCall();
	});
}

fuelbuddy.resetSearchLogs = function() {
	
	// Reset all the search inputs
	$("#odometer_search_input").val("");
	$("#odometer_search_dropdown").val("gt");
    $("#service_type_search_dropdown").val("");
    $("#search_date_picker").val("");
	$("#date_search_dropdown").val("gt");
	$("#search_logs_input").val("");
					
    // Get the logs and load the table	
	$("#logs_table tbody").empty();
	
	fuelbuddy.beforeCall();
	jQuery.getJSON(fuelbuddy.LOGS_PHP + "?" + 'vehid=' + fuelbuddy.current_vehicle_id, "", function(data) {
		fuelbuddy.loadLogTable("logs_table", "", data, false);
	})
	.always(function() {
	    fuelbuddy.afterCall();
	});
}

fuelbuddy.beforeCall = function() {
	$("#loading_modal").modal('show');
}

fuelbuddy.afterCall = function() {
	$("#loading_modal").modal('hide');
}

fuelbuddy.setCurrentUserEmail = function() {
	fuelbuddy.current_user_email = fuelbuddy.global_settings["email"];
	$("#logout-email").html(fuelbuddy.current_user_email);
}

fuelbuddy.updateUsername = function() {
    gapi.load('auth2', function(){
      // Retrieve the singleton for the GoogleAuth library and set up the client.
      auth2 = gapi.auth2.init({
        client_id: "336428349177-ltd2t026eo1b9bvu9o8ic8ud0d5a0mml.apps.googleusercontent.com",
        cookiepolicy: 'single_host_origin',
		  scope: 'profile email'
      });
	  
	  // Sign the user in, and then retrieve their ID.
	  auth2.signIn().then(function() {
	    $("#logout-email").html(auth2.currentUser.get().getBasicProfile().getName());
	  });
    });
};

fuelbuddy.showMobileWarning = function() {
	var isMobile = false;
	if(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|ipad|iris|kindle|Android|Silk|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(navigator.userAgent) 
	    || /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(navigator.userAgent.substr(0,4))) isMobile = true;
	if (isMobile) {
		$("#mobile-warning").show();
		$("#mobile-warning-close").click(function() {
			$("#mobile-warning").hide();
		});
	}
}

// To make sure the responsive menu collapses after a click on mobile platforms
// From https://github.com/twbs/bootstrap/issues/12852
$(document).on('click','.navbar-collapse.in',function(e) {
    if( $(e.target).is('a') ) {
        $(this).collapse('hide');
    }
});